
-- declaring local variables that will be used only inside map-functions.lua
local tileW, tileH, tileset, quads, tileTable

function loadMap(path)
  love.filesystem.load(path)() -- attention! extra parenthesis
end

function newMap(tileWidth, tileHeight, tilesetPath, tileString, quadInfo)
  
  tileW = tileWidth
  tileH = tileHeight
  tileset = love.graphics.newImage(tilesetPath)
  
  local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
  
  quads = {}
  
  for _,info in ipairs(quadInfo) do
    -- info[1] = the character, info[2] = x, info[3] = y
    quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW, tileH, tilesetW, tilesetH)
  end
  
  tileTable = {}
  
  local width = #(tileString:match("[^\n]+"))

  for x = 1,width,1 do tileTable[x] = {} end

  local rowIndex,columnIndex = 1,1
  for row in tileString:gmatch("[^\n]+") do
    assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    columnIndex = 1
    for character in row:gmatch(".") do
      tileTable[columnIndex][rowIndex] = character
      columnIndex = columnIndex + 1

      	if tileTable[5][3] ~= '#' then
	      --love.graphics.print("fuckoyou",400,400)
	end
	
      --love.graphics.setColor(255,255,255)
      --love.graphics.print(character,100,100)

    end
    rowIndex=rowIndex+1
  end

end

function drawMap()
	love.graphics.setColor(255,255,255)
  	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0
      		love.graphics.draw(tileset, quads[ char ] , x, y)

      		--[[if tileTable[columnIndex][rowIndex] == '.' then
	     	 	love.graphics.print("FUCK YOU",x,y)
		end]] -- TEST CONCEPT WORKS
   	 end
  	end
end

function playercheck(dx,dy)

	dx = 0
	dy = 0

	--playertile = 791

	
	love.graphics.setColor(0,255,0)
	love.graphics.print("$",(playertilex-1)*12+200,(playertiley-1)*12)

	if tileTable[playertilex][playertiley-1] == '#' then --UP
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.print("$",(playertilex-1)*12+200,(playertiley-2)*12)
		--playertile = playertile - 50
	elseif tileTable[playertilex][playertiley+1] == '#' then --DOWN
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.print("$",(playertilex-1)*12+200,(playertiley)*12)

	elseif tileTable[playertilex+1][playertiley] == '#' then --RIGHT
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.print("$",(playertilex)*12+200,(playertiley-1)*12)
	
	elseif tileTable[playertilex-1][playertiley] == '#' then --LEFT
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.print("$",(playertilex-2)*12+200,(playertiley-1)*12)

	end

	if tileTable[playertilex + dx][playertiley + dy] == '#' then
		return false
	end
		return true
	

end




